package MultiCastZoo;

import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigInteger;
import java.net.Socket;
import java.security.MessageDigest;
import java.util.ArrayList;
/**
 * CommandParser - A vulnerable protected command
 * execution class.
 * Written for a security exercise in
 * Computer Network Security  (ECE 6612 Spring 2008)
 * at Georgia Tech
 * @author David Bauer and Chris Lee
 *
 */
public class CommandParser {
	static String pw = "TEAMS: Change this!";
	static String challenge = "NobodyWillGuessThis";
	static String Shell = "/bin/sh";
	static String [] ShellOps = { "-c" };
	static String[] AllowedCommands = { "df", "echo", "hostname", "id", "last", "ls", "nm", "ping", "uname", "w", "who"};

	public static void receiveMessage(String message) {
		try {
			MessageDigest md5 = MessageDigest.getInstance("MD5");
			if(message.startsWith("CMDReq")) {
				MultiCastZoo.sendMsg("CMDRep,"+challenge);
			} else if(message.startsWith("CMDRep")) {
				// ignore it
			} else if(message.startsWith("CMDAuth")) {
				//correct format is: CMDAuth,MD5(challenge|pw),challenge,ip,port,cmd
				String[] parts = message.split(",");
				String cmd = parts[5];
				String port = parts[4];
				String ip = parts[3];
				String chal = parts[2];
				String resp = parts[1];

				byte[] result = md5.digest((chal+pw).getBytes());
				BigInteger number = new BigInteger(1,result);
				String md5str = number.toString(16);
				if(md5str.equals(resp))
					execute(ip,Integer.parseInt(port),cmd.split(" "));
			}
		} catch(Exception e) {
			System.out.println(e);
		}
	}

	public static void execute(String ip, int port, String[] command) {
		boolean success = false;
		for (String allowedCommand : AllowedCommands) {
			if(command[0].equals(allowedCommand)) {
				success = true;
				break;
			}
		}
		if (!success) {
			System.out.println("Command \"" + command[0] + "\" not allowed.");
			return;
		}

		ArrayList<String> buildCommand = new ArrayList<String>();
		buildCommand.add(Shell);
		for (String s : ShellOps) buildCommand.add(s);
		String cmdLine = "";
		for (String s : command) cmdLine += s + " ";
		buildCommand.add(cmdLine);
		command = buildCommand.toArray(new String[0]);

		try {
			Socket sock = new Socket(ip, port);
			OutputStream os = sock.getOutputStream();
			Process p = Runtime.getRuntime().exec(command, null);
			InputStream is = p.getInputStream();
			int len;
			byte[] buf = new byte[1024];
			while((len = is.read(buf)) > 0) {
				os.write(buf, 0, len);
				// System.out.println(new String(buf));
			}
			is.close();
			os.close();
			p.destroy();
		} catch(Exception e) {
			System.out.println(e);
		}
	}

}
